unit pmddedp;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, PMDDE1, DdeMan, FileCtrl;

type
  TForm1 = class(TForm)
    DdeClientConv1: TDdeClientConv;
    PmDDE1: TPmDDE;
    Button1: TButton;
    Log: TListBox;
    Label1: TLabel;
    FList: TFileListBox;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
const
  XCenter  =  105;
  YCenter  =  90;
var
  FOptions :  array[1..1] of TFilterParams;  {  just stub  }

begin
  with PmDDE1 do begin
    Log.Items.Clear;
    Log.Items.Add('Initialization!');
    StartConnection;
    Log.Items.Add('Set measure units - millimiters');
    {  Pagemaker needs to use '.' as decimal separator,
    but some country (Russia for example) use '.' or other  }
    {  Strongly recommended  }
    DecimalSeparator:='.';
    MeasureUnits(millimeters, millimeters, 10);
    Log.Items.Add('Creating new publication');
    New(1);
    Log.Items.Add('Page Setup');
    PageSize(210, 297);
    Log.Items.Add('Creating colors');
    {  component dont work with hi-fi colors but its possible  }
    {  now I use process CMYK colors  }
    DefineColor('SSCyan', process, cmyk, false, 100, 0, 0, 0, '');
    DefineColor('SSMagenta', process, cmyk, false, 0, 100, 0, 0, '');
    DefineColor('SSYellow', process, cmyk, false, 0, 0, 100, 0, '');
    DefineColor('SSBlack', process, cmyk, false, 0, 0, 0, 100, '');
    DefineColor('SSWhite', process, cmyk, false, 0, 0, 0, 0, '');
    Log.Items.Add('Creating rectangles');
    Box(75, 20, 135, 80);
    FillAndLine(solid, 'SSYellow', false, none, false, 0, false, '', false, 100, 100);
    Rotate(_center, 45);
    Copy;

    Move(_leftbottom, XCenter, YCenter);

    Paste;
    Move(_righttop, XCenter, YCenter);
    FillAndLine(solid, 'SSCyan', false, none, false, 0, false, '', false, 100, 100);

    Paste;
    Move(_rightbottom, XCenter, YCenter);
    FillAndLine(solid, 'SSMagenta', false, none, false, 0, false, '', false, 100, 100);

    Paste;
    Move(_lefttop, XCenter, YCenter);
    FillAndLine(solid, 'SSBlack', false, none, false, 0, false, '', false, 100, 100);
    NewStory(105, 148);
    Log.Items.Add('Entering text');
    TextEnter('Automate Your PageMaker with PmDDE component'+Chr(13));
    TextEnter('Register It! e-mail: zolotov_serg@zahadum.com');
    SelectAll;
    Alignment(Center);
    Size(16);
    Color('SSWhite', 100);
    Tool(pointer);
    GetObjectIDListTop;
    {  text is last object - select it as object  }
    SelectID(PmObjects[PmObjectCount-1].nObjectID);
    Log.Items.Add('Setting text');
    Move(_center, XCenter, YCenter);
    SelectAll;
    Group;
    FList.FileName:=Application.ExeName;
    LongOperation:=True;
    Log.Items.Add('Importing TPmDDE.jpg graphics...');
    Import(FList.Directory+'\tpmdde.jpg', independent, boolfalse, boolfalse,
      boolfalse, boolfalse, 0, FOptions);
    Place(0, 0);
    LongOperation:=False;
    Move(_center, XCenter, YCenter);
    Move(_top, 0, YCenter+90);
    SendToBack;
    Preferences(dontcare, dontcare, highres,
      dontcare, dontcare, dontcare, dontcare, dontcare,
      dontcare, dontcare, dontcare, dontcare,
      1, 1,dontcare);
    Log.Items.Add('Stop connection');
    StopConnection;

  end
end;

end.
